# IBM_PROLOG_BEGIN_TAG 
# This is an automatically generated prolog. 
#  
#  
#  
# Licensed Materials - Property of IBM 
#  
# (C) COPYRIGHT International Business Machines Corp. 2002 
# All Rights Reserved 
#  
# US Government Users Restricted Rights - Use, duplication or 
# disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
#  
# IBM_PROLOG_END_TAG 
#####################################################################
#                                                                   #
# Module:  InstallDefs.pm                                           #
#                                                                   #
#                                                                   #
# Description:   This module contains subroutines and definitions   #
#             that are used by multiple other commands.             #
#                                                                   #
# Subroutines:                                                      #
#                                                                   #
# Notes:                                                            #
#                                                                   #
#####################################################################
# @(#)54   1.36.1.25   src/csm/install/InstallDefs.pm.perl, setup, csm_rori, rorit1d2 9/13/02 18:24:32

package InstallDefs;

BEGIN  {
    use File::Basename;      # - this gives us the path of the command
    ($::Bin) = dirname($0);  # - for this command we assume the modules and 
                             #     message maps are in the same place
}
use lib "$::Bin";

use NodeUtils;


#-------------------------------------------------------------------
#    Global Definitions
#-------------------------------------------------------------------

$::NOK=1;
$::OK=0;

$::LS         =  "/bin/ls";
$::MOVE       =  "/bin/mv";
$::LN         =  "/bin/ln";
$::RM         =  "/bin/rm";
$::MV         =  "/bin/mv";
$::CAT        =  "/bin/cat";
$::MKDIR      =  "/bin/mkdir";
$::CHMOD      =  "/bin/chmod";
$::COPY       =  "/bin/cp";
$::EXPORTFS   =  "/usr/sbin/exportfs";
$::RPMCMD     =  "/bin/rpm";
$::UNAME      =  "/bin/uname";
$::CSMTOP     = "/opt/csm";
$::CSMREQS    = $::CSMTOP  . "/reqs";
$::CSMBIN     = $::CSMTOP  . "/bin";
$::CSMCSMBIN  = $::CSMTOP  . "/csmbin";
$::DSH        = $::CSMBIN  . "/dsh";
$::UPDATENODE = $::CSMBIN  . "/updatenode";
$::CREATENODE = $::CSMCSMBIN . "/createnode";
$::ATFTP      = "/usr/bin/atftp";
$::LSOF       = "/usr/sbin/lsof";
$::ESPTTY     = "/usr/bin/esptty";
$::GREP       = "/bin/grep";
$::TOUCH      = "/bin/touch";
$::SLEEP      = "/bin/sleep";
$::GUNZIP     = "/bin/gunzip";
$::GZIP       = "/bin/gzip";
$::IFCONFIG   = "/sbin/ifconfig";
$::NETSTAT    = "/bin/netstat";
$::TAIL       = "/usr/bin/tail";
$::TAR        = "/bin/tar";




$::TFTPBOOT   			= "/tftpboot";
$::PXELINUX_CFG_DIR     = "/tftpboot/pxelinux.cfg";
$::RPOWER  		        = $::CSMBIN . "/rpower";
$::MONITORINSTALL       = $::CSMBIN . "/monitorinstall";

#csm commands
$::MKGETMACRD           = "/opt/csm/csmbin/mkgetmacrd";
$::GETMACS              = "/opt/csm/bin/getmacs";
$::CREATEDHCP           = "/opt/csm/csmbin/createdhcp";
$::UPDATEDHCP           = "/opt/csm/csmbin/updatedhcp";

$::CSM2NIMGRPS          = $::CSMBIN  . "/csm2nimgrps";
$::CSM2NIMNODES         = $::CSMBIN  . "/csm2nimnodes";
$::NODEGRP              = $::CSMBIN  . "/nodegrp";


# CSM definitions
$::LOGFILE_HANDLE       = undef;
$::CSMLOG                = "/var/log/csm";
$::CSMSETUPKS_LOG        = $::CSMLOG . "/csmsetupks.log";
$::INSTALLNODE_LOG       = $::CSMLOG . "/installnode.log";
$::MAKENODE_LOG          = $::CSMLOG . "/makenode.log";
$::UPDATENODE_LOG        = $::CSMLOG . "/updatenode.log";
$::CSMPREREBOOT_LOG      = $::CSMLOG . "/csmprereboot.log";
$::CSMFIRSTBOOT_LOG      = $::CSMLOG . "/csmfirstboot.log";
$::INSTALLMSLOG          = $::CSMLOG . "/installms.log";
$::INSTALL_LOG           = "/var/log/csm/install.log";

$::CSMSETUPSIS_LOG        = $::CSMLOG . "/csmsetupsis.log";
$::INSTALLSISLOG         = $::CSMLOG . "/installsis.log";

$::LSNODE                =  "/opt/csm/bin/lsnode";
$::CHNODE                =  "/opt/csm/bin/chnode";
$::MGMTSVR               =  "/opt/csm/bin/mgmtsvr";
$::CFORCE                =  "/opt/csm/bin/cfmupdatenode";
$::CFGINFOFILE           =  "/opt/csm/install/configinfo";
$::CSMCFGDIR             =  "/csminstall/csm/config/";
$::NODEMAP_FILE          =  "$::CSMCFGDIR/nodemap";
$::CSMINSTDIR            =  "/csminstall";
$::OPTCSMINSTALL         =  "/opt/csm/install";
$::RMNODE                =  "/opt/csm/bin/rmnode";

#$::PLTFRM = InstallUtils->get_OSName();
if(NodeUtils->isLinux()==1){
       $::PLTFRM                = "Linux";
}
elsif(NodeUtils->isAIX()==1){
       $::PLTFRM                = "AIX";
}

$::DISTRIBUTION= NodeUtils->distribution();
# commands that are unique to an operating system
#   or are located in different places
if ($::PLTFRM eq "AIX") {

  $::MKNFS                 =  "/usr/sbin/mknfs";
  $::MOUNT                 =  "/usr/sbin/mount";
  $::UNMOUNT               =  "/usr/sbin/umount";
  $::PING                  =  "/etc/ping";
  $::INSTALLPCMD           =  "/usr/sbin/installp";
  $::MKITAB                =  "/usr/sbin/mkitab";
  $::RMITAB                =  "/usr/sbin/rmitab";
  $::LSITAB                =  "/usr/sbin/lsitab";
  $::NIMINFO               =  "/etc/niminfo";
  $::NIM                   =  "/usr/sbin/nim";
  $::LSNIM                 =  "/usr/sbin/lsnim";
  $::MKNFSEXP              =  "/usr/sbin/mknfsexp";
  $::LSRSRC                =  "/bin/lsrsrc";
  $::LSRSRC_API		       =  "/bin/lsrsrc-api";
  $::OSLEVEL               =  "/bin/oslevel";
  $::LSLPP                 =  "/bin/lslpp";
  $::HEAD                  =  "/bin/head";
  $::RESTORE               =  "/usr/sbin/restore";
  $::RPM2CPIO              =  "/bin/rpm2cpio";
  $::CUT                   =  "/usr/bin/cut";
  $::CPIO                  =  "/bin/cpio";

} else {  # Linux versions

  $::SERVICE    =  "/sbin/service";
  $::MOUNT      =  "/bin/mount";
  $::UNMOUNT    =  "/bin/umount";
  $::PING       =  "/bin/ping";
  $::LSRSRC     =  "/usr/bin/lsrsrc";
  $::LSRSRC_API =  "/usr/bin/lsrsrc-api";
  $::HEAD       =  "/usr/bin/head";
  $::RPM2CPIO   =  "/usr/bin/rpm2cpio";
  $::CPIO       =  "/bin/cpio";

  if( $::DISTRIBUTION =~ /SuSE/ ){
    $::LSOF       = "/usr/bin/lsof";
  }

}

# The human-readable name of the distribution
$::DISTRO_NAME{'RedHat 6.2'}    = "Red Hat Linux 6.2";
$::DISTRO_NAME{'RedHat 7.0'}    = "Red Hat Linux 7.0";
$::DISTRO_NAME{'RedHat 7.1'}    = "Red Hat Linux 7.1";
$::DISTRO_NAME{'RedHat 7.2'}    = "Red Hat Linux 7.2";
$::DISTRO_NAME{'RedHat 7.3'}    = "Red Hat Linux 7.3";
$::DISTRO_NAME{'SuSE 7.3'}      = "SuSE Linux 7.3";
$::DISTRO_NAME{'SuSE 8.0'}      = "SuSE Linux 8.0";
$::DISTRO_NAME{'SuSE-SLES 7.2'} = "SuSE-SLES Linux 7.2";

$::DISTRO_SHORTNAME{'RedHat 6.2'}       = "rh62";
$::DISTRO_SHORTNAME{'RedHat 7.0'}       = "rh70";
$::DISTRO_SHORTNAME{'RedHat 7.1'}       = "rh71";
$::DISTRO_SHORTNAME{'RedHat 7.2'}       = "rh72";
$::DISTRO_SHORTNAME{'RedHat 7.3'}       = "rh73";
$::DISTRO_SHORTNAME{'SuSE 7.3'}         = "suse73";
$::DISTRO_SHORTNAME{'SuSE 8.0'}         = "suse80";
$::DISTRO_SHORTNAME{'SuSE-SLES 7.2'}    = "sles72";

$::DISTRO_SHORTNAMEKS{'RedHat 6.2'}     = "ks62";
$::DISTRO_SHORTNAMEKS{'RedHat 7.0'}     = "ks70";
$::DISTRO_SHORTNAMEKS{'RedHat 7.1'}     = "ks71";
$::DISTRO_SHORTNAMEKS{'RedHat 7.2'}     = "ks72";
$::DISTRO_SHORTNAMEKS{'RedHat 7.3'}     = "ks73";
$::DISTRO_SHORTNAMEKS{'SuSE 7.3'}       = "ksuse73";
$::DISTRO_SHORTNAMEKS{'SuSE 8.0'}       = "ksuse80";
$::DISTRO_SHORTNAMEKS{'SuSE-SLES 7.2'}  = "ksles72";

# A list of numbers corresponding to the number of CD-ROMs in the distribution
$::DISTRO_DISKLIST{'RedHat 6.2'}        = "1";
$::DISTRO_DISKLIST{'RedHat 7.0'}        = "1 2";
$::DISTRO_DISKLIST{'RedHat 7.1'}        = "1 2";
$::DISTRO_DISKLIST{'RedHat 7.2'}        = "1 2";
$::DISTRO_DISKLIST{'RedHat 7.3'}        = "1 2 3";
$::DISTRO_DISKLIST{'SuSE 7.3'}          = "1 2 3 4 5";
$::DISTRO_DISKLIST{'SuSE 8.0'}          = "1 2 3 4 5";
$::DISTRO_DISKLIST{'SuSE-SLES 7.2'}     = "1";

# The directory under which the RPMs reside on the RedHat distribution CD-ROM(s)
$::DISTRO_RPMDIR{'RedHat 6.2'}     = "RedHat/RPMS";
$::DISTRO_RPMDIR{'RedHat 7.0'}     = "RedHat/RPMS";
$::DISTRO_RPMDIR{'RedHat 7.1'}     = "RedHat/RPMS";
$::DISTRO_RPMDIR{'RedHat 7.2'}     = "RedHat/RPMS";
$::DISTRO_RPMDIR{'RedHat 7.3'}     = "RedHat/RPMS";
$::DISTRO_RPMDIR{'SuSE 7.3'}       = "full-names";
$::DISTRO_RPMDIR{'SuSE 8.0'}       = "suse";
$::DISTRO_RPMDIR{'SuSE-SLES 7.2'}  = "full-names";

# List of supported distributions
@::VALID_DISTROS  = (
                  'RedHat 6.2',
                  'RedHat 7.0',
                  'RedHat 7.1',
                  'RedHat 7.2',
                  'RedHat 7.3',
                  'SuSE 7.3',
                  'SuSE 8.0',
                  'SuSE-SLES 7.2',
                  );
@::VALID_AIX_DISTROS = (
                  'AIX5.1.0',
                  );
@::VALID_CSM_DISTROS = (
                  '1.2.0',
                  );


$::DISTRO = "";
@::valid_powermethod=();
@::valid_console=();


# Open Source Pre-requisities
# assigning $opensrc_prereqs{<filesetname>}{<oslevel&version>}{<fileset version>}=[<List of prerequists>]

$::opensrc_prereqs{'csm.core'}{'LinuxRedHat7.3'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.core'}{'LinuxRedHat7.2'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.core'}{'LinuxRedHat7.1'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.core'}{'AIX5.1.0'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.core'}{'LinuxSuSE7.3'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.core'}{'LinuxSuSE8.0'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.core'}{'LinuxSuSE-SLES7.2'}{'1.2.0'} = [];

$::opensrc_prereqs{'csm.server'}{'LinuxRedHat7.3'}{'1.2.0'} = ['atftp','syslinux','IBMJava2-JRE-1.3'];
$::opensrc_prereqs{'csm.server'}{'LinuxRedHat7.2'}{'1.2.0'} = ['atftp','syslinux','IBMJava2-JRE-1.3'];
$::opensrc_prereqs{'csm.server'}{'LinuxRedHat7.1'}{'1.2.0'} = ['atftp','syslinux','IBMJava2-JRE-1.3'];
$::opensrc_prereqs{'csm.server'}{'AIX5.1.0'}{'1.2.0'} = ['openCIMOM','rdist','tcl','tk','expect'];
$::opensrc_prereqs{'csm.server'}{'LinuxSuSE7.3'}{'1.2.0'} = ['atftp','syslinux','IBMJava2-JRE-1.3'];
$::opensrc_prereqs{'csm.server'}{'LinuxSuSE8.0'}{'1.2.0'} = ['atftp','syslinux','IBMJava2-JRE-1.3'];
$::opensrc_prereqs{'csm.server'}{'LinuxSuSE-SLES7.2'}{'1.2.0'} = ['atftp','syslinux','IBMJava2-JRE-1.3','rdist','expect'];


$::opensrc_prereqs{'csm.client'}{'LinuxRedHat7.3'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.client'}{'LinuxRedHat7.2'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.client'}{'LinuxRedHat7.1'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.client'}{'AIX5.1.0'}{'1.2.0'} = ['rdist'];
$::opensrc_prereqs{'csm.client'}{'LinuxSuSE7.3'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.client'}{'LinuxSuSE8.0'}{'1.2.0'} = [];
$::opensrc_prereqs{'csm.client'}{'LinuxSuSE-SLES7.2'}{'1.2.0'} = ['rdist'];

# Managemente Server rsct & csm pacakges
# assigning $rsct_packages/$csm_packages{<MgmtSvr>}{<oslevel&version>}{<fileset version>}=[<List of prerequists>]

$::rsct_packages{'MgmtSvr'}{'LinuxRedHat7.3'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgmtSvr'}{'LinuxRedHat7.2'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgmtSvr'}{'LinuxRedHat7.1'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgmtSvr'}{'AIX5.1.0'}{'1.2.0'}=[];
$::rsct_packages{'MgmtSvr'}{'LinuxSuSE7.3'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgmtSvr'}{'LinuxSuSE8.0'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgmtSvr'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];

$::csm_packages{'MgmtSvr'}{'LinuxRedHat7.3'}{'1.2.0'}=['csm.core','csm.dsh','csm.server','csm.gui.dcem'];
$::csm_packages{'MgmtSvr'}{'LinuxRedHat7.2'}{'1.2.0'}=['csm.core','csm.dsh','csm.server','csm.gui.dcem'];
$::csm_packages{'MgmtSvr'}{'LinuxRedHat7.1'}{'1.2.0'}=['csm.core','csm.dsh','csm.server','csm.gui.dcem'];
$::csm_packages{'MgmtSvr'}{'AIX5.1.0'}{'1.2.0'}=['csm.core','csm.dsh','csm.server','csm.gui'];
$::csm_packages{'MgmtSvr'}{'LinuxSuSE7.3'}{'1.2.0'}=['csm.core','csm.dsh','csm.server','csm.gui.dcem'];
$::csm_packages{'MgmtSvr'}{'LinuxSuSE8.0'}{'1.2.0'}=['csm.core','csm.dsh','csm.server','csm.gui.dcem'];
$::csm_packages{'MgmtSvr'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['csm.core','csm.dsh','csm.server','csm.gui.dcem'];

# Managemente Server rsct & csm uninstall pacakges
# assigning $rsct_unpackages/$csm_unpackages{<MgmtSvr>}{<oslevel&version>}{<fileset version>}=[<List of prerequists>]
$::rsct_unpackages{'MgmtSvr'}{'LinuxRedHat7.3'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_unpackages{'MgmtSvr'}{'LinuxRedHat7.2'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_unpackages{'MgmtSvr'}{'LinuxRedHat7.1'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_unpackages{'MgmtSvr'}{'AIX5.1.0'}{'1.2.0'}=[];
$::rsct_unpackages{'MgmtSvr'}{'LinuxSuSE7.3'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_unpackages{'MgmtSvr'}{'LinuxSuSE8.0'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_unpackages{'MgmtSvr'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];

$::csm_unpackages{'MgmtSvr'}{'LinuxRedHat7.3'}{'1.2.0'}=['csm.dsh','csm.server','csm.gui.dcem'];
$::csm_unpackages{'MgmtSvr'}{'LinuxRedHat7.2'}{'1.2.0'}=['csm.dsh','csm.server','csm.gui.dcem'];
$::csm_unpackages{'MgmtSvr'}{'LinuxRedHat7.1'}{'1.2.0'}=['csm.dsh','csm.server','csm.gui.dcem'];
$::csm_unpackages{'MgmtSvr'}{'AIX5.1.0'}{'1.2.0'}=['csm.dsh','csm.server','csm.gui'];
$::csm_unpackages{'MgmtSvr'}{'LinuxSuSE8.0'}{'1.2.0'}=['csm.dsh','csm.server','csm.gui.dcem'];
$::csm_unpackages{'MgmtSvr'}{'LinuxSuSE7.3'}{'1.2.0'}=['csm.dsh','csm.server','csm.gui.dcem'];
$::csm_unpackages{'MgmtSvr'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['csm.dsh','csm.server','csm.gui.dcem'];

$::csmUnistallList_dir{'MgmtSvr'}{'LinuxRedHat7.3'}{'1.2.0'}=['/csminstall','/cfmroot'];
$::csmUnistallList_dir{'MgmtSvr'}{'LinuxRedHat7.2'}{'1.2.0'}=['/csminstall','/cfmroot'];
$::csmUnistallList_dir{'MgmtSvr'}{'LinuxRedHat7.1'}{'1.2.0'}=['/csminstall','/cfmroot'];
$::csmUnistallList_dir{'MgmtSvr'}{'AIX5.1.0'}{'1.2.0'}=['/csminstall','/cfmroot'];
$::csmUnistallList_dir{'MgmtSvr'}{'LinuxSuSE7.3'}{'1.2.0'}=['/csminstall','/cfmroot'];
$::csmUnistallList_dir{'MgmtSvr'}{'LinuxSuSE8.0'}{'1.2.0'}=['/csminstall','/cfmroot'];
$::csmUnistallList_dir{'MgmtSvr'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['/csminstall','/cfmroot'];

$::csmUnistallList_pack{'MgmtSvr'}{'LinuxRedHat7.3'}{'1.2.0'}=['csm.core'];
$::csmUnistallList_pack{'MgmtSvr'}{'LinuxRedHat7.2'}{'1.2.0'}=['csm.core'];
$::csmUnistallList_pack{'MgmtSvr'}{'LinuxRedHat7.1'}{'1.2.0'}=['csm.core'];
$::csmUnistallList_pack{'MgmtSvr'}{'AIX5.1.0'}{'1.2.0'}=['csm.core'];
$::csmUnistallList_pack{'MgmtSvr'}{'LinuxSuSE7.3'}{'1.2.0'}=['csm.core'];
$::csmUnistallList_pack{'MgmtSvr'}{'LinuxSuSE8.0'}{'1.2.0'}=['csm.core'];
$::csmUnistallList_pack{'MgmtSvr'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['csm.core'];


# Managed Node  rsct & csm pacakges
# assigning $rsct_packages/csm_packages{<MgdNode>}{<oslevel&version>}{<fileset version>}=[<List of prerequists>]

$::rsct_packages{'MgdNode'}{'LinuxRedHat7.3'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgdNode'}{'LinuxRedHat7.2'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgdNode'}{'LinuxRedHat7.1'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgdNode'}{'AIX5.1.0'}{'1.2.0'}=[];
$::rsct_packages{'MgdNode'}{'LinuxSuSE7.3'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgdNode'}{'LinuxSuSE8.0'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];
$::rsct_packages{'MgdNode'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['src','rsct.core.utils','rsct.core'];

$::csm_packages{'MgdNode'}{'LinuxRedHat7.3'}{'1.2.0'}=['csm.core','csm.client'];
$::csm_packages{'MgdNode'}{'LinuxRedHat7.2'}{'1.2.0'}=['csm.core','csm.client'];
$::csm_packages{'MgdNode'}{'LinuxRedHat7.1'}{'1.2.0'}=['csm.core','csm.client'];
$::csm_packages{'MgdNode'}{'AIX5.1.0'}{'1.2.0'}=['csm.core','csm.client'];
$::csm_packages{'MgdNode'}{'LinuxSuSE7.3'}{'1.2.0'}=['csm.core','csm.client'];
$::csm_packages{'MgdNode'}{'LinuxSuSE8.0'}{'1.2.0'}=['csm.core','csm.client'];
$::csm_packages{'MgdNode'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['csm.core','csm.client'];

# Csm binaries copied to /csminstall/csm directory
# assigning $csm_bin_copy_csm{<oslevel&version>}{<fileset version>}=[<List of prerequists>]


$::csm_bin_copy_csm{'LinuxRedHat7.3'}{'1.2.0'}=['/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/pm/NodeUtils.pm','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/nodecmds.NodeUtils.map','/opt/csm/bin/setupconsole'];
$::csm_bin_copy_csm{'LinuxRedHat7.2'}{'1.2.0'}=['/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/pm/NodeUtils.pm','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/nodecmds.NodeUtils.map','/opt/csm/bin/setupconsole'];

$::csm_bin_copy_csm{'LinuxRedHat7.1'}{'1.2.0'}=['/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/pm/NodeUtils.pm','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/nodecmds.NodeUtils.map','/opt/csm/bin/setupconsole'];

$::csm_bin_copy_csm{'AIX5.1.0'}{'1.2.0'}=['/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/pm/NodeUtils.pm','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csm{'LinuxSuSE7.3'}{'1.2.0'}=['/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/pm/NodeUtils.pm','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csm{'LinuxSuSE8.0'}{'1.2.0'}=['/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/pm/NodeUtils.pm','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csm{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/pm/NodeUtils.pm','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];


# Csm binaries copied to /tftpboot directory
# assigning $csm_bin_copy_tftpboot{<oslevel&version>}{<fileset version>}=[<List of prerequists>]


$::csm_bin_copy_tftpboot{'LinuxRedHat7.3'}{'1.2.0'}=['/usr/lib/syslinux/pxelinux.0'];
$::csm_bin_copy_tftpboot{'LinuxRedHat7.2'}{'1.2.0'}=['/usr/lib/syslinux/pxelinux.0'];
$::csm_bin_copy_tftpboot{'LinuxRedHat7.1'}{'1.2.0'}=['/usr/lib/syslinux/pxelinux.0'];
$::csm_bin_copy_tftpboot{'AIX5.1.0'}{'1.2.0'}=[];
$::csm_bin_copy_tftpboot{'LinuxSuSE7.3'}{'1.2.0'}=['/usr/lib/syslinux/pxelinux.0'];
$::csm_bin_copy_tftpboot{'LinuxSuSE8.0'}{'1.2.0'}=['/usr/lib/syslinux/pxelinux.0'];
$::csm_bin_copy_tftpboot{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['/usr/lib/syslinux/pxelinux.0'];

# Csm binaries copied to /csminstall/csm/<csmVersion> directory
# assigning $csm_bin_copy_csmver{<oslevel&version>}{<fileset version>}=[<List of prerequists>]

$::csm_bin_copy_csmver{'LinuxRedHat7.3'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/usr/bin/atftp','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csm_bin_copy_csmver{'LinuxRedHat7.2'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/usr/bin/atftp','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csmver{'LinuxRedHat7.1'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/usr/bin/atftp','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csmver{'AIX5.1.0'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csmver{'LinuxSuSE7.3'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/usr/bin/atftp','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csmver{'LinuxSuSE8.0'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/usr/bin/atftp','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csm_bin_copy_csmver{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/usr/bin/atftp','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

# BEGIN OBSOLETE VARIABLES

$::csm_bin_copyfiles{'LinuxRedHat7.3'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/csmbin/write_status','/usr/bin/atftp','/usr/lib/syslinux/pxelinux.0','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csm_bin_copyfiles{'LinuxRedHat7.2'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/csmbin/write_status','/usr/bin/atftp','/usr/lib/syslinux/pxelinux.0','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csm_bin_copyfiles{'LinuxRedHat7.1'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/csmbin/write_status','/usr/bin/atftp','/usr/lib/syslinux/pxelinux.0','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csm_bin_copyfiles{'AIX5.1.0'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/csmbin/write_status','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csm_bin_copyfiles{'LinuxSuSE7.3'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/csmbin/write_status','/usr/bin/atftp','/usr/lib/syslinux/pxelinux.0','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csm_bin_copyfiles{'LinuxSuSE8.0'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/csmbin/write_status','/usr/bin/atftp','/usr/lib/syslinux/pxelinux.0','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csm_bin_copyfiles{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['/opt/csm/csmbin/makenode','/opt/csm/pm/NodeUtils.pm','/opt/csm/bin/csmsetup.pm','/opt/csm/csmbin/updatenode.client','/opt/csm/csmbin/csmprereboot','/opt/csm/csmbin/csmfirstboot','/opt/csm/pm/InstallUtils.pm','/opt/csm/pm/InstallDefs.pm','/opt/csm/msgmaps/csmInstall.csminstall.map','/opt/csm/csmbin/write_status','/usr/bin/atftp','/usr/lib/syslinux/pxelinux.0','/opt/csm/msgmaps/nodecmds.NodeUtils.map'];

# END OBSOLETE VARIABLES

# OS pre-requisites for the CSM 
# assigning $Linux_os_prereqs{<oslevel&version>}=[<List of prerequists>]

$::Linux_os_prereqs{'LinuxRedHat7.3'}=['perl-5*','nfs-utils-*','pdksh-*','dhcp-*','rdist-6*','expect-5.32*','tcl-8.3*','tk-8.3*','XFree86-libs-4.2*','freetype-2.0*'];
$::Linux_os_prereqs{'LinuxRedHat7.2'}=['perl-5*','nfs-utils-*','pdksh-*','dhcp-*','rdist-6*','expect-5.32*','tcl-8.3*','tk-8.3*','XFree86-libs-4.1*','freetype-2.0*'];
$::Linux_os_prereqs{'LinuxRedHat7.1'}=['perl-5*','nfs-utils-*','pdksh-*','dhcp-*','rdist-6*','expect-5.31*','tcl-8.3*','tk-8.3*','XFree86-libs-4.0*','freetype-2.0*'];
$::Linux_os_prereqs{'AIX5.1.0'}=[];
$::Linux_os_prereqs{'LinuxSuSE7.3'}=['perl-5*','nfs-utils-*','pdksh-*','dhcp-3*','rdist-6*','expect-5*','tcl-8*','tk-8*','xf86*','freetype2*','termcap-*','rsync-*'];
$::Linux_os_prereqs{'LinuxSuSE8.0'}=['perl-5*','nfs-utils-*','pdksh-*','dhcp-server-*','dhcp-base-*','rdist-6*','expect-5*','tcl-8*','tk-8*','xf86*','freetype2*','termcap-*','rsync-*','rsh-server-*'];
$::Linux_os_prereqs{'LinuxSuSE-SLES7.2'}=['perl-5*','nfs-utils-*','pdksh-*','termcap-*','dhcp-*','tcl-8*','tk-8*','xf86*','freetype2*','rsync-*'];


# Log files of CSM Management server  ( used while uninstalling)
# assigning $logfiles{'MgmtSvr'}{<oslevel&version>}=[<List of prerequists>]

$::logfiles{'MgmtSvr'}{'LinuxRedHat7.1'}=['/var/log/csm/csmsetupks.log*','/var/log/csm/installnode.log*','/var/log/csm/updatenode.log*','/var/log/csm/installms.log*'];

$::logfiles{'MgmtSvr'}{'LinuxRedHat7.3'}=['/var/log/csm/csmsetupks.log*','/var/log/csm/installnode.log*','/var/log/csm/updatenode.log*','/var/log/csm/installms.log*'];
$::logfiles{'MgmtSvr'}{'LinuxRedHat7.2'}=['/var/log/csm/csmsetupks.log*','/var/log/csm/installnode.log*','/var/log/csm/updatenode.log*','/var/log/csm/installms.log*'];

$::logfiles{'MgmtSvr'}{'AIX5.1.0'}=['/var/log/csm/updatenode.log*','/var/log/csm/installms.log*'];

$::logfiles{'MgmtSvr'}{'LinuxSuSE7.3'}=['/var/log/csm/csmsetupks.log*','/var/log/csm/installnode.log*','/var/log/csm/updatenode.log*','/var/log/csm/installms.log*'];

$::logfiles{'MgmtSvr'}{'LinuxSuSE8.0'}=['/var/log/csm/csmsetupks.log*','/var/log/csm/installnode.log*','/var/log/csm/updatenode.log*','/var/log/csm/installms.log*'];

$::logfiles{'MgmtSvr'}{'LinuxSuSE-SLES7.2'}=['/var/log/csm/csmsetupks.log*','/var/log/csm/installnode.log*','/var/log/csm/updatenode.log*','/var/log/csm/installms.log*'];

# Log files of CSM Managed Node  ( used while uninstalling)
# assigning $logfiles{'MgdNode'}{<oslevel&version>}=[<List of prerequists>]

$::logfiles{'MgdNode'}{'LinuxRedHat7.1'}=['/var/log/csm/install.log*','/var/opt/csm/cfmlocal*'];
$::logfiles{'MgdNode'}{'LinuxRedHat7.2'}=['/var/log/csm/install.log*','/var/opt/csm/cfmlocal*'];
$::logfiles{'MgdNode'}{'LinuxRedHat7.3'}=['/var/log/csm/install.log*','/var/opt/csm/cfmlocal*'];
$::logfiles{'MgdNode'}{'AIX5.1.0'}=['/var/log/csm/install.log*','/var/opt/csm/cfmlocal*'];
$::logfiles{'MgdNode'}{'LinuxSuSE7.3'}=['/var/log/csm/install.log*','/var/opt/csm/cfmlocal*'];
$::logfiles{'MgdNode'}{'LinuxSuSE8.0'}=['/var/log/csm/install.log*','/var/opt/csm/cfmlocal*'];
$::logfiles{'MgdNode'}{'LinuxSuSE-SLES7.2'}=['/var/log/csm/install.log*','/var/opt/csm/cfmlocal*'];

# Files that need to extraced from CSM.Core package (Used for copycsmpkgs) 
# assigning $csmbin{'csm.core'}{<oslevel&version>}{<fileset version>}=[<List of prerequists>]

$::csmbin{'csm.core'}{'LinuxRedHat7.1'}{'1.2.0'}=['opt/csm/pm/NodeUtils.pm','opt/csm/bin/csmsetup.pm','opt/csm/pm/InstallUtils.pm','opt/csm/pm/InstallDefs.pm','opt/csm/msgmaps/csmInstall.csminstall.map','opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csmbin{'csm.core'}{'LinuxRedHat7.2'}{'1.2.0'}=['opt/csm/pm/NodeUtils.pm','opt/csm/bin/csmsetup.pm','opt/csm/pm/InstallUtils.pm','opt/csm/pm/InstallDefs.pm','opt/csm/msgmaps/csmInstall.csminstall.map','opt/csm/msgmaps/nodecmds.NodeUtils.map'];
$::csmbin{'csm.core'}{'LinuxRedHat7.3'}{'1.2.0'}=['opt/csm/pm/NodeUtils.pm','opt/csm/bin/csmsetup.pm','opt/csm/pm/InstallUtils.pm','opt/csm/pm/InstallDefs.pm','opt/csm/msgmaps/csmInstall.csminstall.map','opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csmbin{'csm.core'}{'AIX5.1.0'}{'1.2.0'}=['opt/csm/pm/NodeUtils.pm','opt/csm/bin/csmsetup.pm','opt/csm/pm/InstallUtils.pm','opt/csm/pm/InstallDefs.pm','opt/csm/msgmaps/csmInstall.csminstall.map','opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csmbin{'csm.core'}{'LinuxSuSE7.3'}{'1.2.0'}=['opt/csm/pm/NodeUtils.pm','opt/csm/bin/csmsetup.pm','opt/csm/pm/InstallUtils.pm','opt/csm/pm/InstallDefs.pm','opt/csm/msgmaps/csmInstall.csminstall.map','opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csmbin{'csm.core'}{'LinuxSuSE8.0'}{'1.2.0'}=['opt/csm/pm/NodeUtils.pm','opt/csm/bin/csmsetup.pm','opt/csm/pm/InstallUtils.pm','opt/csm/pm/InstallDefs.pm','opt/csm/msgmaps/csmInstall.csminstall.map','opt/csm/msgmaps/nodecmds.NodeUtils.map'];

$::csmbin{'csm.core'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['opt/csm/pm/NodeUtils.pm','opt/csm/bin/csmsetup.pm','opt/csm/pm/InstallUtils.pm','opt/csm/pm/InstallDefs.pm','opt/csm/msgmaps/csmInstall.csminstall.map','opt/csm/msgmaps/nodecmds.NodeUtils.map'];

# Files that need to extraced from CSM.Server package (Used for copycsmpkgs) 
# assigning $csmbin{'csm.server'}{<oslevel&version>}{<fileset version>}=[<List of prerequists>]

$::csmbin{'csm.server'}{'LinuxRedHat7.1'}{'1.2.0'}=['opt/csm/csmbin/makenode','opt/csm/csmbin/csmprereboot','opt/csm/csmbin/csmfirstboot'];
$::csmbin{'csm.server'}{'LinuxRedHat7.2'}{'1.2.0'}=['opt/csm/csmbin/makenode','opt/csm/csmbin/csmprereboot','opt/csm/csmbin/csmfirstboot'];
$::csmbin{'csm.server'}{'LinuxRedHat7.3'}{'1.2.0'}=['opt/csm/csmbin/makenode','opt/csm/csmbin/csmprereboot','opt/csm/csmbin/csmfirstboot'];
$::csmbin{'csm.server'}{'AIX5.1.0'}{'1.2.0'}=['opt/csm/csmbin/makenode','opt/csm/csmbin/csmprereboot','opt/csm/csmbin/csmfirstboot'];
$::csmbin{'csm.server'}{'LinuxSuSE7.3'}{'1.2.0'}=['opt/csm/csmbin/makenode','opt/csm/csmbin/csmprereboot','opt/csm/csmbin/csmfirstboot'];
$::csmbin{'csm.server'}{'LinuxSuSE8.0'}{'1.2.0'}=['opt/csm/csmbin/makenode','opt/csm/csmbin/csmprereboot','opt/csm/csmbin/csmfirstboot'];
$::csmbin{'csm.server'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['opt/csm/csmbin/makenode','opt/csm/csmbin/csmprereboot','opt/csm/csmbin/csmfirstboot'];

# File that need to extraced from open source package (Used for copycsmpkgs)
# assigning $csmbinOpenSrc{'opensrc'}{<oslevel&version>}{<fileset version>}=[<List of prerequists>]

$::csmbin{'opensrc'}{'LinuxRedHat7.1'}{'1.2.0'}=['usr/bin/atftp'];
$::csmbin{'opensrc'}{'LinuxRedHat7.2'}{'1.2.0'}=['usr/bin/atftp'];
$::csmbin{'opensrc'}{'LinuxRedHat7.3'}{'1.2.0'}=['usr/bin/atftp'];
$::csmbin{'opensrc'}{'AIX5.1.0'}{'1.2.0'}=[];
$::csmbin{'opensrc'}{'LinuxSuSE7.3'}{'1.2.0'}=['usr/bin/atftp'];
$::csmbin{'opensrc'}{'LinuxSuSE8.0'}{'1.2.0'}=['usr/bin/atftp'];
$::csmbin{'opensrc'}{'LinuxSuSE-SLES7.2'}{'1.2.0'}=['usr/bin/atftp'];

1;  # end
